#define CLK_0 digitalWrite(12, 0)
#define CLK_1 digitalWrite(12, 1)
#define LCK_0 digitalWrite(10, 0)
#define LCK_1 digitalWrite(10, 1)
#define MOSI_0 digitalWrite(11, 0)
#define MOSI_1 digitalWrite(11, 1)

unsigned char number[8] = {1,2,3,4,5,6,7,8};

unsigned char number_display[11] = {
  0b00111111,
  0b00000110,
  0b01011011,
  0b01001111,
  0b01100110,
  0b01101101,
  0b01111101,
  0b00000111,
  0b01111111,
  0b01101111,
  0b01000000
};

unsigned char key[16] = {0};

void shift_in(unsigned char x1, unsigned char x2)
{
  int i = 0;
  CLK_1;
  LCK_0;
  for (i = 0; i < 8; i++)
  {
    if (x1 & 0x80)
      MOSI_1;
    else
      MOSI_0;
    x1 <<= 1;
    CLK_0;
    CLK_1;
  }

  for (i = 0; i < 8; i++)
  {
    if (x2 & 0x80)
      MOSI_1;
    else
      MOSI_0;
    x2 <<= 1;
    CLK_0;
    CLK_1;
  }
  
  LCK_1;
  LCK_0;
}

void setup() {
  // put your setup code here, to run once:
  pinMode(10, OUTPUT);  //LCK
  pinMode(11, OUTPUT);  //MOSI
  pinMode(12, OUTPUT);  //CLK

  pinMode(2, 0);
  pinMode(3, 0);
  pinMode(4, 0);
  pinMode(5, 0);
  pinMode(6, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  Serial.begin(115200);
  
}

void display_8(int number)
{
  int bit_number = 8;
  if (number < 0)
  {
    number = -number;
    bit_number = 7;
  }
  for (int i = 0; i < bit_number; i++)
  {
    shift_in(~(1<<(7 - i)), number_display[number%10]);
    number /= 10;
    if (number == 0)
    {
      if (bit_number == 7)
      {
        shift_in(~(1<<(7 - i - 1)), number_display[10]);
      }
      break;
    }
  }
}
#define BUF_NUM 20

unsigned int sample(unsigned char port, float error)
{
  static unsigned int sample_buf[BUF_NUM] = {0};
  static unsigned int buf_index = 0;  
  static unsigned int analog_number = 0, analog_number_dis = 0;;
  int err = 0;
  int total = 0;
  analog_number = analogRead(port);

  for (int i = 0; i < BUF_NUM; i++)
  {
    err += (sample_buf[buf_index] - analog_number);
  }
  if (err > error * BUF_NUM || err < -(error * BUF_NUM))
  {
    analog_number_dis = analog_number;
    
    for (int i = 0; i < BUF_NUM; i++)
    {
      sample_buf[buf_index] = analog_number_dis;
    }
    sample_buf[buf_index++] = analog_number;
    if (buf_index >= BUF_NUM)
      buf_index = 0;
   }
  return analog_number_dis;
}

void key_scan()
{  for (int i = 2; i <= 5; i++)
  {
    pinMode(i, 1);
    digitalWrite(i, 0);
    delayMicroseconds(1);
    for (int j = 6; j <= 9; j++)
    {
      if (digitalRead(j))
      {
        key[(i-2) * 4 + (j - 6)] = 1;
      }
      else
      {
        key[(i-2) * 4 + (j - 6)] = 0;
      }
    }
    digitalWrite(i, 1);
    pinMode(i, 0);
  }
//  for (int i = 0; i < 16; i++)
//  {
//    Serial.print(key[i]);
//    Serial.print(' ');
//  }
//  Serial.print('\n');
}

void loop() {
  static char mode = 0;
  switch (mode)
  {
    case 0:
      display_8(sample(2,2));
      break;
    case 1:
      display_8(sample(0,20));
      break;
    case 2:
      display_8(sample(1,2));
      break;
  }
  key_scan();
  if (key[0] == 0)
    mode = 0;
  if (key[1] == 0)
    mode = 1;
  if (key[2] == 0)
    mode = 2;
}

